//*************************************************************************************
//  : SQ7653_I2C_Master.h
// 汾     : V1.0 2020/07/17A
//      : I2C ͷļ
// ע     :  
//**************************************************************************************
#ifndef _SQ7653_I2C_MASTER_H__
#define _SQ7653_I2C_MASTER_H__

/* ---------------------- Զ ------------------------------ */
#define SLAVE_ADDR 0x68
#define I2C_0      0x00
#define I2C_Master    1

#define I2C_Write   0x00
#define I2C_Read    0x01

#define I2C_ACK        0
#define I2C_NACK       1

#define BIT0  0x0001
#define BIT1  0x0002
#define BIT2  0x0004
#define BIT3  0x0008
#define BIT4  0x0010
#define BIT5  0x0020
#define BIT6  0x0040
#define BIT7  0x0080
#define BIT8  0x0100
#define BIT9  0x0200
#define BIT10 0x0400
#define BIT11 0x0800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000

//bufcount : I2Cbit
#define BC_8bit      0x00
#define BC_1bit      0x01
#define BC_2bit      0x02
#define BC_3bit      0x03
#define BC_4bit      0x04
#define BC_5bit      0x05
#define BC_6bit      0x06
#define BC_7bit      0x07

// SYSCLK@24MHZ							fscl          // SYSCLK@16MHZ	fscl		
#define SCK_HI_9_LO_12			0x00	//1143 kHz	;  					// 762 kHz
#define SCK_HI_11_LO_14			0x01	// 960 kHz	;  					// 640 kHz
#define SCK_HI_15_LO_18			0x02	// 727 kHz	;  					// 485 kHz
#define SCK_HI_23_LO_26			0x03	// 490 kHz	;  					// 327 kHz
#define SCK_HI_39_LO_42			0x04	// 296 kHz	;  					// 198 kHz
#define SCK_HI_71_LO_74			0x05	// 166 kHz	;  					// 110 kHz
#define SCK_HI_135_LO_138		0x06	//  88 kHz	;  					//  59 kHz
#define SCK_HI_263_LO_266		0x07	//  45 kHz	;  					//  30 kHz

#define SBICR2_MST      BIT7
#define SBICR2_TX       BIT6
#define SBICR2_RX       0x00
#define SBICR2_BB       BIT5
#define SBICR2_PIN      BIT4
#define SBICR2_SBIM     BIT3

#define SBISR_Master    BIT7
#define SBISR_TX        BIT6
#define SBISR_BusBusy   BIT5
#define SBISR_PIN       BIT4
#define SBISR_AL        BIT3
#define SBISR_AAS       BIT2
#define SBISR_AD0       BIT1
#define SBISR_LRB       BIT0


typedef struct{
	unsigned char adr;
	unsigned char cmd;
	unsigned char len;
	unsigned char buf[34];
}I2C_MasterPacket;

/* ---------------------- extern ȫֱ ------------------------- */
extern I2C_MasterPacket   i2c_master;


//----------------------------------------------------------------
void I2C0_Init();
void I2C0_IntEnable();
void I2C0_IntDisable(void);

void I2C_Start(unsigned char adr);
void I2C_ReStart(unsigned char adr);
void I2C_Stop();
void I2C_TXOneByte(unsigned char TxBuf);
unsigned char I2C_RXOneByte();

void I2C_SetBufvalue(unsigned char data);
unsigned char I2C_ReadBufvalue();
void I2C_Reset();

unsigned char I2C_Master_Write(I2C_MasterPacket* pi2c);
unsigned char I2C_Master_Read(I2C_MasterPacket* pi2c);

void __interrupt I2C0_IRQ(void);

#endif


